## ibm-3270 3.3.14ga11

=== wc3270/Makefile ===
# Copyright (c) 2007-2009, 2013-2014 Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Makefile for wc3270

# Figure out if they've installed MinGW OpenSSL.
SSLDIR = /usr/local/OpenSSL-Win32
HAVE_OPENSSL = $(shell [ -d $(SSLDIR) ] && echo yes)
ifeq ($(HAVE_OPENSSL),yes)
ifndef NO_SSL
SSLCPP = -DHAVE_LIBSSL=1 -I$(SSLDIR)/include
#SSLLIB = -L$(SSLDIR)/lib/MinGW $(SSLDIR)/lib/MinGW/ssleay32.a -leay32 -lwsock32 -ladvapi32 -lgdi32 -luser32
SSLLIB = -lwsock32 -ladvapi32 -lgdi32 -luser32
else
OSUFFIX = -insecure
endif
endif

# Set command paths and mkfb (which has to run locally) based on whether
# compiling natively on Cygwin, or cross-compiling on Linux.
OS = $(shell uname -o)
ifeq ($(OS),Cygwin)
MKFB = mkfb.exe
MKKEYPAD = mkkeypad.exe
CC = i686-pc-mingw32-gcc
NATIVECC = gcc
WINDRES = i686-pc-mingw32-gccwindres
else
MKFB = mkfb
MKKEYPAD = mkkeypad
CC = i586-mingw32msvc-gcc
NATIVECC = gcc
WINDRES = i586-mingw32msvc-windres
endif

XCPPFLAGS = -D_WIN32 -D_WIN32_WINNT=0x0500 -D_WIN32_IE=0x0500 -DWINVER=0x500
CFLAGS = $(EXTRA_FLAGS) -g -Wall -Werror $(XCPPFLAGS) -I. $(SSLCPP)
SRCS = XtGlue.c actions.c ansi.c apl.c c3270.c charset.c ctlr.c fallbacks.c \
	fprint_screen.c ft.c ft_cut.c ft_dft.c glue.c help.c host.c icmd.c \
	idle.c keymap.c keypad.c kybd.c macros.c menubar.c print.c printer.c \
	proxy.c readres.c relink.c resolver.c resources.c rpq.c screen.c \
	scroll.c see.c select.c sf.c shortcut.c snprintf.c ssl_dll.c tables.c \
	telnet.c toggles.c trace_ds.c unicode.c unicode_dbcs.c utf8.c util.c \
	w3misc.c windirs.c winprint.c winvers.c xio.c
VOBJS = XtGlue.o actions.o ansi.o apl.o c3270.o charset.o ctlr.o fallbacks.o \
	fprint_screen.o ft.o ft_cut.o ft_dft.o glue.o help.o host.o icmd.o \
	idle.o keymap.o keypad.o kybd.o macros.o menubar.o print.o printer.o \
	proxy.o readres.o relink.o resolver.o resources.o rpq.o screen.o \
	scroll.o see.o select.o sf.o shortcut.o snprintf.o ssl_dll.o tables.o \
	telnet.o toggles.o trace_ds.o unicode.o unicode_dbcs.o utf8.o util.o \
	w3misc.o wc3270res.o windirs.o winprint.o winvers.o xio.o
OBJECTS = $(VOBJS) version.o
WOBJECTS = wizard.o wc3270res.o wversion.o shortcut.o winvers.o windirs.o \
	relink.o snprintf.o
LIBS = $(SSLLIB) -lws2_32 -lole32 -luuid
SHRTLIBS = -lole32 -luuid
WIZLIBS = -lole32 -luuid -lwinspool
DLLFLAGS = $(EXTRA_FLAGS) -mno-cygwin -shared -Wl,--export-all-symbols -Wl,--enable-auto-import

PROGS = wc3270.exe mkshort.exe wc3270wiz.exe catf.exe ead3270.exe x3270if.exe
all: $(PROGS)

wc3270.exe : XCPPFLAGS += -DWIN32_LEAN_AND_MEAN

version.o: $(VOBJS) version.txt mkversion.sh Makefile
	@chmod +x mkversion.sh version.txt
	sh ./mkversion.sh $(CC) wc3270

fallbacks.c: $(MKFB) X3270.xad Makefile
	$(RM) $@
	./$(MKFB) -c X3270.xad $@

$(MKFB): mkfb.c Makefile
	$(NATIVECC) -g -o $(MKFB) -DFOR_WIN32 mkfb.c

keypad.o: keypad.c compiled_keypad.h

compiled_keypad.h: keypad.full keypad.labels keypad.map keypad.outline keypad.callbacks $(MKKEYPAD)
	./$(MKKEYPAD) >$@

$(MKKEYPAD): mkkeypad.c
	$(NATIVECC) -g -o $(MKKEYPAD) mkkeypad.c

wc3270res.o: wc3270.rc wc3270.ico Makefile
	$(WINDRES) -i wc3270.rc -o wc3270res.o

wc3270.exe: $(OBJECTS) Makefile
	$(CC) -o wc3270$(OSUFFIX).exe $(CFLAGS) $(OBJECTS) $(LIBS)

mkshort.exe: mkshort.o shortcut.o winvers.o Makefile
	$(CC) -o mkshort.exe $(CFLAGS) \
		mkshort.o shortcut.o winvers.o $(SHRTLIBS)

wversion.o: version.txt mkwversion.sh
	@chmod +x mkwversion.sh version.txt
	sh ./mkwversion.sh $(CC)

wc3270wiz.exe: $(WOBJECTS)
	$(CC) -o wc3270wiz$(OSUFFIX).exe $(CFLAGS) $(WOBJECTS) $(WIZLIBS)

catf.exe: catf.c
	$(CC) -o catf.exe $(CFLAGS) catf.c

ead3270.exe: ead3270.o windirs.o
	$(CC) -o $@ $(CFLAGS) ead3270.o windirs.o

ead3270.o: ead3270.c
	$(CC) $(CFLAGS) -c ead3270.c

x3270if.exe: x3270if.o w3misc.o
	$(CC) -o $@ $(CFLAGS) x3270if.o w3misc.o -lws2_32

clean:
	rm -f *.o $(MKFB) $(MKKEYPAD) compiled_keypad.h fallbacks.c

clobber: clean
	rm -f $(PROGS)

depend:
	mingwmakedep -C $(CC) $(XCPPFLAGS) -I. $(SRCS) >dependencies

ifeq ($(wildcard dependencies),dependencies)
include dependencies
endif

=== wpr3287/Makefile ===
# Copyright (c) 2007-2014, Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Makefile for wpr3287

# Figure out if they've installed MinGW OpenSSL.
SSLDIR = /usr/local/OpenSSL-Win32
HAVE_OPENSSL = $(shell [ -d $(SSLDIR) ] && echo yes)
ifeq ($(HAVE_OPENSSL),yes)
ifndef NO_SSL
SSLCPP = -DHAVE_LIBSSL=1 -I$(SSLDIR)/include
SSLLIB = -lwsock32 -ladvapi32 -lgdi32 -luser32
else
OSUFFIX = -insecure
endif
endif

# Set command paths based on whether compiling natively on Cygwin, or
# cross-compiling on Linux.
OS = $(shell uname -o)
ifeq ($(OS),Cygwin)
CC = i686-pc-mingw32-gcc
WINDRES = i686-pc-mingw32-windres
else
CC = i586-mingw32msvc-gcc
WINDRES = i586-mingw32msvc-windres
endif

XCPPFLAGS = -D_WIN32 -DX3270_DBCS=1 -D_WIN32_WINNT=0x500 -D_WIN32_IE=0x0500 -DWINVER=0x500
CFLAGS = -g -Wall -Werror $(XCPPFLAGS) -I. $(SSLCPP) $(CDEBUGFLAGS)
SRCS = charset.c ctlr.c pr3287.c proxy.c resolver.c see.c sf.c snprintf.c \
	ssl_dll.c tables.c telnet.c trace_ds.c unicode.c unicode_dbcs.c \
	utf8.c w3misc.c windirs.c winvers.c xtable.c
VOBJS = charset.o ctlr.o pr3287.o proxy.o resolver.o see.o sf.o snprintf.o \
	ssl_dll.o tables.o telnet.o trace_ds.o unicode.o unicode_dbcs.o \
	utf8.o w3misc.o windirs.o winvers.o wpr3287res.o ws.o xtable.o
OBJECTS = $(VOBJS) version.o
LIBS = $(SSLLIB) -lws2_32 -lwinspool

all: wpr3287.exe

version.o: $(VOBJS) version.txt mkversion.sh
	@chmod +x mkversion.sh version.txt
	sh ./mkversion.sh $(CC) wpr3287

wpr3287res.o: wpr3287.rc pr3287.ico
	$(WINDRES) -i wpr3287.rc -o wpr3287res.o

wpr3287.exe: $(OBJECTS)
	$(CC) -o wpr3287$(OSUFFIX).exe $(CFLAGS) $(OBJECTS) $(LIBS)

clean:
	rm -f *.o

clobber: clean
	rm -f wpr3287.exe

depend:
	mingwmakedep -C $(CC) $(XCPPFLAGS) -I. $(SRCS) >dependencies

ifeq ($(wildcard dependencies),dependencies)
include dependencies
endif

=== ws3270/Makefile ===
# Copyright (c) 2007-2009, 2013-2014 Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# Makefile for ws3270

# Figure out if they've installed MinGW OpenSSL.
SSLDIR = /usr/local/OpenSSL-Win32
HAVE_OPENSSL = $(shell [ -d $(SSLDIR) ] && echo yes)
ifeq ($(HAVE_OPENSSL),yes)
ifndef NO_SSL
SSLCPP = -DHAVE_LIBSSL=1 -I$(SSLDIR)/include
#SSLLIB = -L$(SSLDIR)/lib/MinGW $(SSLDIR)/lib/MinGW/ssleay32.a -leay32 -lwsock32 -ladvapi32 -lgdi32 -luser32
SSLLIB = -lwsock32 -ladvapi32 -lgdi32 -luser32
else
OSUFFIX = -insecure
endif
endif

# Set command paths and mkfb (which has to run locally) based on whether
# compiling natively on Cygwin, or cross-compiling on Linux.
OS = $(shell uname -o)
ifeq ($(OS),Cygwin)
MKFB = mkfb.exe
CC = i686-pc-mingw32-gcc
NATIVECC = gcc
WINDRES = i686-pc-mingw32-windres
else
MKFB = mkfb
CC = i586-mingw32msvc-gcc
NATIVECC = gcc
WINDRES = i586-mingw32msvc-windres
endif

XCPPFLAGS = -D_WIN32 -D_WIN32_WINNT=0x0500 -D_WIN32_IE=0x0500 -DWIN32_LEAN_AND_MEAN
CFLAGS = $(EXTRA_FLAGS) -g -Wall -Werror $(XCPPFLAGS) -I. $(SSLCPP)
SRCS = XtGlue.c actions.c ansi.c apl.c charset.c ctlr.c fallbacks.c \
	fprint_screen.c ft.c ft_cut.c ft_dft.c glue.c host.c idle.c kybd.c \
	macros.c print.c printer.c proxy.c readres.c resolver.c resources.c \
	rpq.c see.c sf.c smain.c snprintf.c ssl_dll.c strtok_r.c tables.c \
	telnet.c toggles.c trace_ds.c unicode.c unicode_dbcs.c utf8.c util.c \
	w3misc.c windirs.c winprint.c winvers.c xio.c
VOBJS = XtGlue.o actions.o ansi.o apl.o charset.o ctlr.o fallbacks.o \
	fprint_screen.o ft.o ft_cut.o ft_dft.o glue.o host.o idle.o kybd.o \
	macros.o print.o printer.o proxy.o readres.o resolver.o resources.o \
	rpq.o see.o sf.o smain.o snprintf.o ssl_dll.o strtok_r.o tables.o \
	telnet.o toggles.o trace_ds.o unicode.o unicode_dbcs.o utf8.o util.o \
	w3misc.o windirs.o winprint.o winvers.o ws3270res.o xio.o
OBJECTS = $(VOBJS) version.o
LIBS = $(SSLLIB) -lws2_32
SHRTLIBS = -lole32 -luuid
DLLFLAGS = $(EXTRA_FLAGS) -mno-cygwin -shared -Wl,--export-all-symbols -Wl,--enable-auto-import

PROGS = ws3270.exe
all: $(PROGS)

version.o: $(VOBJS) version.txt mkversion.sh Makefile
	@chmod +x mkversion.sh version.txt
	sh ./mkversion.sh $(CC) ws3270

fallbacks.c: $(MKFB) X3270.xad Makefile
	$(RM) $@
	./$(MKFB) -c X3270.xad $@

$(MKFB): mkfb.c Makefile
	$(NATIVECC) -g -o $(MKFB) -DFOR_WIN32 mkfb.c

ws3270res.o: ws3270.rc ws3270.ico Makefile
	$(WINDRES) -i ws3270.rc -o ws3270res.o

ws3270.exe: $(OBJECTS) Makefile
	$(CC) -o ws3270$(OSUFFIX).exe $(CFLAGS) $(OBJECTS) $(LIBS)

wversion.o: version.txt mkwversion.sh
	@chmod +x mkwversion.sh version.txt
	sh ./mkwversion.sh $(CC)

clean:
	rm -f *.o mkfb mkfb.exe fallbacks.c

clobber: clean
	rm -f $(PROGS)

depend:
	mingwmakedep -C $(CC) $(XCPPFLAGS) -I. $(SRCS) >dependencies

ifeq ($(wildcard dependencies),dependencies)
include dependencies
endif

=== wc3270/Msc/Makefile ===
# Copyright (c) 2007-2014, Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# nmake Makefile for wc3270

# Set command paths.
MKFB = mkfb.exe
MKKEYPAD = mkkeypad.exe
CC = cl /nologo
RC = rc
RM = erase

# This makefile assumes that you have OpenSSL headers in c:\OpenSSL-Win32.
# If they are somewhere else, change SSLDIR below.
SSLDIR = C:\OpenSSL-Win32
!IF EXISTS($(SSLDIR))
SSLDEF = /DHAVE_LIBSSL=1 /I$(SSLDIR)\include
SSLLIB = gdi32.lib
!ENDIF

XCPPFLAGS = /D_WIN32 /D_WIN32_WINNT=0x0500 /D_WIN32_IE=0x0500 /DWINVER=0x500 /D_CRT_SECURE_NO_DEPRECATE /W3 /WX $(SSLDEF)
CFLAGS = $(EXTRA_FLAGS) $(XCPPFLAGS) -I.
VOBJS = XtGlue.obj actions.obj ansi.obj apl.obj c3270.obj charset.obj \
	ctlr.obj fallbacks.obj fprint_screen.obj ft.obj ft_cut.obj ft_dft.obj \
	glue.obj help.obj host.obj icmd.obj idle.obj keymap.obj keypad.obj \
	kybd.obj macros.obj menubar.obj print.obj printer.obj proxy.obj \
	readres.obj relink.obj resolver.obj resources.obj rpq.obj screen.obj \
	scroll.obj see.obj select.obj sf.obj shortcut.obj snprintf.obj \
	ssl_dll.obj tables.obj telnet.obj toggles.obj trace_ds.obj \
	unicode.obj unicode_dbcs.obj utf8.obj util.obj w3misc.obj wc3270.RES \
	windirs.obj winprint.obj winvers.obj xio.obj
OBJECTS = $(VOBJS) version.obj
WOBJECTS = wizard.obj wc3270.RES wversion.obj shortcut.obj winvers.obj \
	windirs.obj relink.obj snprintf.obj
LIBS = $(SSLLIB) ws2_32.lib advapi32.lib user32.lib shell32.lib ole32.lib
SHRTLIBS = ole32.lib
WIZLIBS = ole32.lib winspool.lib advapi32.lib

PROGS = wc3270.exe mkshort.exe wc3270wiz.exe catf.exe ead3270.exe x3270if.exe
all: $(PROGS)

version.obj: $(VOBJS) version.txt mkversion.exe Msc\Makefile
	mkversion.exe
	$(CC) $(CFLAGS) /c version.c
mkversion.exe: Msc\mkversion.c
	$(CC) $(CFLAGS) /Fe$@ Msc\mkversion.c

fallbacks.c: $(MKFB) X3270.xad Msc\Makefile
	$(MKFB) -c X3270.xad $@
fallbacks.obj: fallbacks.c
	$(CC) $(CFLAGS) /c fallbacks.c

$(MKFB): mkfb.c Msc\Makefile
	$(CC) /Fe$(MKFB) $(XCPPFLAGS)  mkfb.c

compiled_keypad.h: keypad.full keypad.labels keypad.map keypad.outline keypad.callbacks $(MKKEYPAD)
	$(MKKEYPAD) >$@

$(MKKEYPAD): mkkeypad.c
	$(CC) /Fe$(MKKEYPAD) $(XCPPFLAGS)  mkkeypad.c

wc3270.RES: wc3270.rc wc3270.ico Msc\Makefile
	$(RC) wc3270.rc

wc3270.exe: $(OBJECTS) Msc\Makefile
	$(CC) /Fewc3270.exe $(CFLAGS) $(OBJECTS) $(LIBS)

mkshort.exe: mkshort.obj shortcut.obj winvers.obj Msc\Makefile
	$(CC) /Femkshort.exe $(CFLAGS) \
		mkshort.obj shortcut.obj winvers.obj $(SHRTLIBS)

wversion.obj: version.txt mkversion.exe
	mkversion.exe -w
	$(CC) $(CFLAGS) /c wversion.c

wc3270wiz.exe: $(WOBJECTS)
	$(CC) /Fewc3270wiz.exe $(CFLAGS) $(WOBJECTS) $(WIZLIBS)

catf.exe: catf.c
	$(CC) /Fecatf.exe $(CFLAGS) catf.c

ead3270.exe: ead3270.obj windirs.obj
	$(CC) /Fe$@ $(CFLAGS) ead3270.obj windirs.obj advapi32.lib

ead3270.obj: ead3270.c
	$(CC) $(CFLAGS) /c ead3270.c

x3270if.exe: x3270if.obj w3misc.obj
	$(CC) /Fe$@ $(CFLAGS) x3270if.obj w3misc.obj ws2_32.lib

x3270if.obj: x3270if.c
	$(CC) $(CFLAGS) /c x3270if.c

clean:
	erase *.obj *.RES *.exp *.lib $(MKFB) $(MKKEYPAD) compiled_keypad.h fallbacks.c mkversion.exe version.c wversion.c

clobber: clean
	erase $(PROGS)

XtGlue.obj: XtGlue.c
	$(CC) $(CFLAGS) /c XtGlue.c
actions.obj: actions.c
	$(CC) $(CFLAGS) /c actions.c
ansi.obj: ansi.c
	$(CC) $(CFLAGS) /c ansi.c
apl.obj: apl.c
	$(CC) $(CFLAGS) /c apl.c
c3270.obj: c3270.c
	$(CC) $(CFLAGS) /c c3270.c
charset.obj: charset.c
	$(CC) $(CFLAGS) /c charset.c
ctlr.obj: ctlr.c
	$(CC) $(CFLAGS) /c ctlr.c
fprint_screen.obj: fprint_screen.c
	$(CC) $(CFLAGS) /c fprint_screen.c
ft.obj: ft.c
	$(CC) $(CFLAGS) /c ft.c
ft_cut.obj: ft.c
	$(CC) $(CFLAGS) /c ft_cut.c
ft_dft.obj: ft_dft.c
	$(CC) $(CFLAGS) /c ft_dft.c
glue.obj: glue.c
	$(CC) $(CFLAGS) /c glue.c
help.obj: help.c
	$(CC) $(CFLAGS) /c help.c
host.obj: host.c
	$(CC) $(CFLAGS) /c host.c
icmd.obj: icmd.c
	$(CC) $(CFLAGS) /c icmd.c
idle.obj: idle.c
	$(CC) $(CFLAGS) /c idle.c
keymap.obj: keymap.c
	$(CC) $(CFLAGS) /c keymap.c
keypad.obj: keypad.c compiled_keypad.h
	$(CC) $(CFLAGS) /c keypad.c
kybd.obj: kybd.c
	$(CC) $(CFLAGS) /c kybd.c
macros.obj: macros.c
	$(CC) $(CFLAGS) /c macros.c
menubar.obj: menubar.c
	$(CC) $(CFLAGS) /c menubar.c
mkshort.obj: mkshort.c
	$(CC) $(CFLAGS) /c mkshort.c
print.obj: print.c
	$(CC) $(CFLAGS) /c print.c
printer.obj: printer.c
	$(CC) $(CFLAGS) /c printer.c
proxy.obj: proxy.c
	$(CC) $(CFLAGS) /c proxy.c
readres.obj: readres.c
	$(CC) $(CFLAGS) /c readres.c
relink.obj: relink.c
	$(CC) $(CFLAGS) /c relink.c
resolver.obj: resolver.c
	$(CC) $(CFLAGS) /c resolver.c
resources.obj: resources.c
	$(CC) $(CFLAGS) /c resources.c
rpq.obj: rpq.c
	$(CC) $(CFLAGS) /c rpq.c
screen.obj: screen.c
	$(CC) $(CFLAGS) /c screen.c
scroll.obj: scroll.c
	$(CC) $(CFLAGS) /c scroll.c
see.obj: see.c
	$(CC) $(CFLAGS) /c see.c
select.obj: select.c
	$(CC) $(CFLAGS) /c select.c
sf.obj: sf.c
	$(CC) $(CFLAGS) /c sf.c
snprintf.obj: snprintf.c
	$(CC) $(CFLAGS) /c snprintf.c
ssl_dll.obj: ssl_dll.c
	$(CC) $(CFLAGS) /c ssl_dll.c
tables.obj: tables.c
	$(CC) $(CFLAGS) /c tables.c
telnet.obj: telnet.c
	$(CC) $(CFLAGS) /c telnet.c
toggles.obj: toggles.c
	$(CC) $(CFLAGS) /c toggles.c
trace_ds.obj: trace_ds.c
	$(CC) $(CFLAGS) /c trace_ds.c
unicode.obj: unicode.c
	$(CC) $(CFLAGS) /c unicode.c
unicode_dbcs.obj: unicode_dbcs.c
	$(CC) $(CFLAGS) /c unicode_dbcs.c
utf8.obj: utf8.c
	$(CC) $(CFLAGS) /c utf8.c
util.obj: util.c
	$(CC) $(CFLAGS) /c util.c
winvers.obj: winvers.c
	$(CC) $(CFLAGS) /c winvers.c
windirs.obj: windirs.c
	$(CC) $(CFLAGS) /c windirs.c
shortcut.obj: shortcut.c
	$(CC) $(CFLAGS) /c shortcut.c
wizard.obj: wizard.c
	$(CC) $(CFLAGS) /c wizard.c
w3misc.obj: w3misc.c
	$(CC) $(CFLAGS) /c w3misc.c
winprint.obj: winprint.c
	$(CC) $(CFLAGS) /c winprint.c
xio.obj: xio.c
	$(CC) $(CFLAGS) /c xio.c

=== wpr3287/Msc/Makefile ===
# Copyright (c) 2007-2014, Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# nmake Makefile for wpr3287

# Set command paths.
CC = cl /nologo
RC = rc
RM = erase

# This makefile assumes that you have OpenSSL headers in c:\OpenSSL-Win32.
# If they are somewhere else, change SSLDIR below.
SSLDIR = C:\OpenSSL-Win32
!IF EXISTS($(SSLDIR))
SSLDEF = /DHAVE_LIBSSL=1 /I$(SSLDIR)\include
SSLLIB = gdi32.lib user32.lib
!ENDIF

XCPPFLAGS = /D_WIN32 /DX3270_DBCS=1 /D_CRT_SECURE_NO_DEPRECATE /D_WIN32_WINNT=0x0500 /D_WIN32_IE=0x0500 /W3 /WX $(SSLDEF)
CFLAGS = $(XCPPFLAGS) -I.
VOBJS = charset.obj ctlr.obj pr3287.obj proxy.obj resolver.obj see.obj sf.obj \
	snprintf.obj ssl_dll.obj tables.obj telnet.obj trace_ds.obj \
	unicode.obj unicode_dbcs.obj utf8.obj w3misc.obj windirs.obj \
	winvers.obj wpr3287.RES ws.obj xtable.obj
OBJECTS = $(VOBJS) version.obj
LIBS = $(SSLLIB) ws2_32.lib winspool.lib advapi32.lib

all: wpr3287.exe

version.obj: $(VOBJS) version.txt mkversion.exe Msc\Makefile
	mkversion.exe wpr3287
	$(CC) $(CFLAGS) /c version.c
mkversion.exe: Msc\mkversion.c
	$(CC) $(CFLAGS) /Fe$@ Msc\mkversion.c

wpr3287.RES: wpr3287.rc pr3287.ico
	$(RC) wpr3287.rc

wpr3287.exe: $(OBJECTS)
	$(CC) /Fewpr3287.exe $(CFLAGS) $(OBJECTS) $(LIBS)

clean:
	$(RM) *.obj *.RES mkversion.exe version.c

clobber: clean
	$(RM) wpr3287.exe

charset.obj: charset.c
	$(CC) $(CFLAGS) /c charset.c
ctlr.obj: ctlr.c
	$(CC) $(CFLAGS) /c ctlr.c
pr3287.obj: pr3287.c
	$(CC) $(CFLAGS) /c pr3287.c
proxy.obj: proxy.c
	$(CC) $(CFLAGS) /c proxy.c
resolver.obj: resolver.c
	$(CC) $(CFLAGS) /c resolver.c
see.obj: see.c
	$(CC) $(CFLAGS) /c see.c
sf.obj: sf.c
	$(CC) $(CFLAGS) /c sf.c
snprintf.obj: snprintf.c
	$(CC) $(CFLAGS) /c snprintf.c
ssl_dll.obj: ssl_dll.c
	$(CC) $(CFLAGS) /c ssl_dll.c
tables.obj: tables.c
	$(CC) $(CFLAGS) /c tables.c
telnet.obj: telnet.c
	$(CC) $(CFLAGS) /c telnet.c
trace_ds.obj: trace_ds.c
	$(CC) $(CFLAGS) /c trace_ds.c
unicode.obj: unicode.c
	$(CC) $(CFLAGS) /c unicode.c
unicode_dbcs.obj: unicode_dbcs.c
	$(CC) $(CFLAGS) /c unicode_dbcs.c
utf8.obj: utf8.c
	$(CC) $(CFLAGS) /c utf8.c
w3misc.obj: w3misc.c
	$(CC) $(CFLAGS) /c w3misc.c
windirs.obj: windirs.c
	$(CC) $(CFLAGS) /c windirs.c
winvers.obj: winvers.c
	$(CC) $(CFLAGS) /c winvers.c
ws.obj: ws.c
	$(CC) $(CFLAGS) /c ws.c
xtable.obj: xtable.c
	$(CC) $(CFLAGS) /c xtable.c

=== ws3270/Msc/Makefile ===
# Copyright (c) 2007-2014, Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# nmake Makefile for ws3270

# Set command paths.
MKFB = mkfb.exe
CC = cl /nologo
RC = rc
RM = erase

# This makefile assumes that you have OpenSSL headers in c:\OpenSSL-Win32.
# If they are somewhere else, change SSLDIR below.
SSLDIR = C:\OpenSSL-Win32
!IF EXISTS($(SSLDIR))
SSLDEF = /DHAVE_LIBSSL=1 /I$(SSLDIR)\include
SSLLIB = gdi32.lib
!ENDIF

XCPPFLAGS = /D_WIN32 /D_WIN32_WINNT=0x0500 /D_WIN32_IE=0x0500 /D_CRT_SECURE_NO_DEPRECATE /DWIN32_LEAN_AND_MEAN /W3 /WX $(SSLDEF)
CFLAGS = $(EXTRA_FLAGS) $(XCPPFLAGS) -I.
VOBJS = XtGlue.obj actions.obj ansi.obj apl.obj charset.obj ctlr.obj \
	fallbacks.obj fprint_screen.obj ft.obj ft_cut.obj ft_dft.obj glue.obj \
	host.obj idle.obj kybd.obj macros.obj print.obj printer.obj proxy.obj \
	readres.obj resolver.obj resources.obj rpq.obj see.obj sf.obj \
	smain.obj snprintf.obj ssl_dll.obj tables.obj telnet.obj toggles.obj \
	trace_ds.obj unicode.obj unicode_dbcs.obj utf8.obj util.obj \
	w3misc.obj windirs.obj winprint.obj winvers.obj ws3270.RES xio.obj
OBJECTS = $(VOBJS) version.obj
LIBS = $(SSLLIB) ws2_32.lib advapi32.lib user32.lib
SHRTLIBS = ole32.lib
WIZLIBS = ole32.lib winspool.lib advapi32.lib

PROGS = ws3270.exe
all: $(PROGS)

version.obj: $(VOBJS) version.txt mkversion.exe Msc\Makefile
	mkversion.exe
	$(CC) $(CFLAGS) /c version.c
mkversion.exe: Msc\mkversion.c
	$(CC) $(CFLAGS) /Fe$@ Msc\mkversion.c

fallbacks.c: $(MKFB) X3270.xad Msc\Makefile
	$(MKFB) -c X3270.xad $@
fallbacks.obj: fallbacks.c
	$(CC) $(CFLAGS) /c fallbacks.c

$(MKFB): mkfb.c Msc\Makefile
	$(CC) /Fe$(MKFB) $(XCPPFLAGS) mkfb.c

ws3270.RES: ws3270.rc ws3270.ico Msc\Makefile
	$(RC) ws3270.rc

ws3270.exe: $(OBJECTS) Msc\Makefile
	$(CC) /Fews3270.exe $(CFLAGS) $(OBJECTS) $(LIBS)

wversion.obj: version.txt mkversion.exe
	mkversion.exe -w
	$(CC) $(CFLAGS) /c wversion.c

clean:
	erase *.obj *.RES *.exp *.lib $(MKFB) fallbacks.c mkversion.exe version.c wversion.c

clobber: clean
	erase $(PROGS)

XtGlue.obj: XtGlue.c
	$(CC) $(CFLAGS) /c XtGlue.c
actions.obj: actions.c
	$(CC) $(CFLAGS) /c actions.c
ansi.obj: ansi.c
	$(CC) $(CFLAGS) /c ansi.c
apl.obj: apl.c
	$(CC) $(CFLAGS) /c apl.c
charset.obj: charset.c
	$(CC) $(CFLAGS) /c charset.c
ctlr.obj: ctlr.c
	$(CC) $(CFLAGS) /c ctlr.c
fprint_screen.obj: fprint_screen.c
	$(CC) $(CFLAGS) /c fprint_screen.c
ft.obj: ft.c
	$(CC) $(CFLAGS) /c ft.c
ft_cut.obj: ft.c
	$(CC) $(CFLAGS) /c ft_cut.c
ft_dft.obj: ft_dft.c
	$(CC) $(CFLAGS) /c ft_dft.c
glue.obj: glue.c
	$(CC) $(CFLAGS) /c glue.c
host.obj: host.c
	$(CC) $(CFLAGS) /c host.c
idle.obj: idle.c
	$(CC) $(CFLAGS) /c idle.c
kybd.obj: kybd.c
	$(CC) $(CFLAGS) /c kybd.c
macros.obj: macros.c
	$(CC) $(CFLAGS) /c macros.c
print.obj: print.c
	$(CC) $(CFLAGS) /c print.c
printer.obj: printer.c
	$(CC) $(CFLAGS) /c printer.c
proxy.obj: proxy.c
	$(CC) $(CFLAGS) /c proxy.c
readres.obj: readres.c
	$(CC) $(CFLAGS) /c readres.c
resolver.obj: resolver.c
	$(CC) $(CFLAGS) /c resolver.c
resources.obj: resources.c
	$(CC) $(CFLAGS) /c resources.c
rpq.obj: rpq.c
	$(CC) $(CFLAGS) /c rpq.c
see.obj: see.c
	$(CC) $(CFLAGS) /c see.c
sf.obj: sf.c
	$(CC) $(CFLAGS) /c sf.c
smain.obj: smain.c
	$(CC) $(CFLAGS) /c smain.c
snprintf.obj: snprintf.c
	$(CC) $(CFLAGS) /c snprintf.c
ssl_dll.obj: ssl_dll.c
	$(CC) $(CFLAGS) /c ssl_dll.c
tables.obj: tables.c
	$(CC) $(CFLAGS) /c tables.c
telnet.obj: telnet.c
	$(CC) $(CFLAGS) /c telnet.c
toggles.obj: toggles.c
	$(CC) $(CFLAGS) /c toggles.c
trace_ds.obj: trace_ds.c
	$(CC) $(CFLAGS) /c trace_ds.c
unicode.obj: unicode.c
	$(CC) $(CFLAGS) /c unicode.c
unicode_dbcs.obj: unicode_dbcs.c
	$(CC) $(CFLAGS) /c unicode_dbcs.c
utf8.obj: utf8.c
	$(CC) $(CFLAGS) /c utf8.c
util.obj: util.c
	$(CC) $(CFLAGS) /c util.c
xio.obj: xio.c
	$(CC) $(CFLAGS) /c xio.c
winvers.obj: winvers.c
	$(CC) $(CFLAGS) /c winvers.c
windirs.obj: windirs.c
	$(CC) $(CFLAGS) /c windirs.c
mkshort.obj: mkshort.c
	$(CC) $(CFLAGS) /c mkshort.c
shortcut.obj: shortcut.c
	$(CC) $(CFLAGS) /c shortcut.c
wizard.obj: wizard.c
	$(CC) $(CFLAGS) /c wizard.c
w3misc.obj: w3misc.c
	$(CC) $(CFLAGS) /c w3misc.c
winprint.obj: winprint.c
	$(CC) $(CFLAGS) /c winprint.c

=== debian/changelog ===
ibm-3270 (3.3.14ga11-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 09:41:57 +0000

ibm-3270 (3.3.14ga11-1) unstable; urgency=medium

  * New upstream version.
  * Don't use imake.
    - Don't install app-defaults file anymore.
  * Enable PIE.
  * Use as-needed to avoid some unused libraries linked in.
  * Use Debhelper compat 9.

 -- Bastian Blank <waldi@debian.org>  Fri, 03 Oct 2014 22:17:31 +0200

=== debian/control ===
Source: ibm-3270
Section: non-free/net
Priority: optional
Maintainer: Bastian Blank <waldi@debian.org>
Standards-Version: 3.7.3
Build-Depends: debhelper (>> 9), autotools-dev, libncursesw5-dev, libssl-dev, libxaw7-dev, libxt-dev, xbitmaps, xfonts-utils, xutils-dev
XS-Autobuild: yes

Package: x3270
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
Recommends: xfonts-x3270-misc
Description: X11 program for telnet sessions to IBM mainframes
 x3270 opens a telnet connection to an IBM mainframe host in an X11
 window.  It can also connect to an IBM AS/400 as a 5250 terminal
 using the AS/400's 3270 emulation.  The window created by x3270 can
 use its own font for displaying characters, so it is a fairly
 accurate representation of an IBM 3278 or 3279.
 .
 x3270 is similar to tn3270(1) and c3270(1) except that it is X-based,
 not curses-based.
 .
 x3270 implements RFCs 2355 (TN3270E), 1576 (TN3270),
 and 1646 (LU name selection), and supports IND$FILE file transfer.
 .
 You will need to install x3270-fonts locally, or on your font-server -
 they are required.

Package: c3270
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
Description: Curses program for telnet sessions to IBM mainframes
 c3270 opens a telnet connection to an IBM mainframe host in an Xterm
 window or Virtual Console.  It can also connect to an IBM AS/400 as 
 a 5250 terminal using the AS/400's 3270 emulation.
 .
 c3270 is similar to tn3270(1), and x3270(1) except that it is curses-based,
 not X-based.
 .
 c3270 implements RFCs 2355 (TN3270E), 1576 (TN3270),
 and 1646 (LU name selection), and supports IND$FILE file transfer.

Package: pr3287
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
Description: IBM 3287 printer emulation for telnet sessions to IBM mainframes
 pr3287 opens a telnet connection to an IBM mainframe host and emulates an
 IBM 3287 printer.
 .
 pr3278 implements RFCs 2355 (TN3270E), 1576 (TN3270),
 and 1646 (LU name selection).

Package: s3270
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
Description: Program for scripted telnet sessions to IBM mainframes
 s3270 opens a telnet connection to an IBM mainframe host, then allows a 
 script to control the host login session.
 .
 s3270 implements RFCs 2355 (TN3270E), 1576 (TN3270),
 and 1646 (LU name selection), and supports IND$FILE file transfer.

Package: 3270-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Common files for IBM 3270 emulators and pr3287
 3270-common contains files referenced in other 3270 packages

Package: xfonts-x3270-misc
Architecture: all
Section: non-free/fonts
Depends: ${misc:Depends}
Description: Font files for the x3270(1) IBM 3270 emulator
 x3270-fonts provides only the fonts required for x3270 operation, so that
 the fonts may be installed separately on a font-server.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+pie
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
LDFLAGS += -Wl,--as-needed

BUILD_DIR = debian/build
STAMPS_DIR = debian/stamps

PARTS = c3270 s3270 pr3287 x3270

setup: $(addprefix $(STAMPS_DIR)/setup_,$(PARTS))

$(STAMPS_DIR)/setup_%: DIR = $(BUILD_DIR)/build_$*
$(STAMPS_DIR)/setup_%:
	@[ -d $(STAMPS_DIR) ] || mkdir -p $(STAMPS_DIR)
	@rm -rf $(DIR)
	mkdir -p $(BUILD_DIR)
	cp -a $* $(DIR)
	rm -f $(DIR)/config.guess $(DIR)/config.sub
	cp -a /usr/share/misc/config.guess /usr/share/misc/config.sub $(DIR)
	cd $(DIR); \
	sh ./configure \
		--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--sysconfdir=/etc \
		--with-fontdir=/usr/share/fonts/X11/misc \
		--without-xmkmf
	touch $@

build: build-arch build-indep
build-indep:
build-arch: $(addprefix $(STAMPS_DIR)/build_,$(PARTS))

$(STAMPS_DIR)/build_%: DIR = $(BUILD_DIR)/build_$*
$(STAMPS_DIR)/build_%: $(STAMPS_DIR)/setup_%
	dh_testdir
	$(MAKE) -C $(DIR)
	touch $@

clean:
	dh_testdir
	rm -rf $(BUILD_DIR) $(STAMPS_DIR)
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(foreach t, $(PARTS), $(MAKE) -C debian/build/build_$(t) install install.man DESTDIR=$(CURDIR)/debian/tmp;)

	dh_install --sourcedir=debian/tmp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -i
	dh_installdocs -i
	dh_installxfonts -i
	dh_link -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -s
	dh_installdocs -s
	dh_installexamples -s
	dh_installman -s
	dh_installmenu -s
	dh_link -s
	dh_strip -s
	dh_compress -s
	dh_fixperms -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install #PHONY_CONFIGURE#

## ibm-3270 3.6ga4

=== lib/w32xx/Makefile ===
# Copyright (c) 2016 Paul Mattes.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Paul Mattes nor his contributors may be used
#       to endorse or promote products derived from this software without
#       specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY PAUL MATTES "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
# NO EVENT SHALL PAUL MATTES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# VPATH-based Makefile for libw32xx, can build either 32- or 64-bit
ifdef WIN64
objdir = ../../obj/win64/lib32xx
else
objdir = ../../obj/win32/lib32xx
endif
top = ../../..
this = $(top)/lib/w32xx

export VPATH = $(this):$(top)/Common/Win32:$(top)/Common
export TOP = $(top)
export THIS = $(this)

MAKEINC = -I$(top)/Common -I$(top)/Common/Win32 -I$(this)

all: $(objdir)
	cd $(objdir) && $(MAKE) $(MAKEINC) -f $(this)/Makefile.obj $@
clean: $(objdir)
	cd $(objdir) && $(MAKE) $(MAKEINC) -f $(this)/Makefile.obj $@
clobber: $(objdir)
	cd $(objdir) && $(MAKE) $(MAKEINC) -f $(this)/Makefile.obj $@
depend: $(objdir)
	cd $(objdir) && $(MAKE) $(MAKEINC) -f $(this)/Makefile.obj $@

$(objdir):
	mkdir -p $(objdir)

=== debian/changelog ===
ibm-3270 (3.6ga4-3) unstable; urgency=medium

  * Let x3270-doc breaks/replaces older versions of x3270 which contained
    the documentation in the main package. (Closes: #891014)

 -- Philipp Kern <pkern@debian.org>  Sat, 03 Mar 2018 10:41:29 +0100

ibm-3270 (3.6ga4-2) unstable; urgency=medium

  * Add two more license/copyright notices from individual files rather
    than top-level LICENSE declaration. (Closes: #889568)

 -- Philipp Kern <pkern@debian.org>  Thu, 15 Feb 2018 23:46:52 +0100

ibm-3270 (3.6ga4-1) unstable; urgency=medium

  * New upstream release.
  * Reintroduce the package into main rather than non-free as the
    licensing issues have been resolved.

 -- Philipp Kern <pkern@debian.org>  Sun, 04 Feb 2018 12:47:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: ibm-3270
-Section: non-free/net
+Section: net
 Priority: optional
-Maintainer: Bastian Blank <waldi@debian.org>
-Standards-Version: 3.7.3
-Build-Depends: debhelper (>> 9), autotools-dev, libncursesw5-dev, libssl-dev, libxaw7-dev, libxt-dev, xbitmaps, xfonts-utils, xutils-dev
-XS-Autobuild: yes
+Maintainer: Philipp Kern <pkern@debian.org>
+Standards-Version: 3.9.7
+Build-Depends: debhelper (>> 9), autotools-dev, libncursesw5-dev, libssl-dev, libxaw7-dev, libxt-dev, xbitmaps, xfonts-utils, xutils-dev, tcl, tcl8.6-dev
+Homepage: http://x3270.bgp.nu/
 
 Package: x3270
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
 Recommends: xfonts-x3270-misc
+Suggests: x3270-doc
 Description: X11 program for telnet sessions to IBM mainframes
  x3270 opens a telnet connection to an IBM mainframe host in an X11
  window.  It can also connect to an IBM AS/400 as a 5250 terminal
@@ -23,12 +24,13 @@
  x3270 implements RFCs 2355 (TN3270E), 1576 (TN3270),
  and 1646 (LU name selection), and supports IND$FILE file transfer.
  .
- You will need to install x3270-fonts locally, or on your font-server -
+ You will need to install x3270's fonts locally, or on your font-server -
  they are required.
 
 Package: c3270
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
+Suggests: x3270-doc
 Description: Curses program for telnet sessions to IBM mainframes
  c3270 opens a telnet connection to an IBM mainframe host in an Xterm
  window or Virtual Console.  It can also connect to an IBM AS/400 as 
@@ -53,6 +55,7 @@
 Package: s3270
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, 3270-common (= ${binary:Version})
+Suggests: x3270-doc
 Description: Program for scripted telnet sessions to IBM mainframes
  s3270 opens a telnet connection to an IBM mainframe host, then allows a 
  script to control the host login session.
@@ -68,9 +71,19 @@
 
 Package: xfonts-x3270-misc
 Architecture: all
-Section: non-free/fonts
+Multi-Arch: foreign
+Section: fonts
 Depends: ${misc:Depends}
 Description: Font files for the x3270(1) IBM 3270 emulator
  x3270-fonts provides only the fonts required for x3270 operation, so that
  the fonts may be installed separately on a font-server.
 
+Package: x3270-doc
+Architecture: all
+Section: doc
+Depends: ${misc:Depends}
+Replaces: x3270 (<< 3.6ga4-1~)
+Breaks: x3270 (<< 3.6ga4-1~)
+Description: X11 program for telnet sessions to IBM mainframes - documentation
+ x3270-doc contains the HTML documentation for the x3270 series of programs
+ that allows one to connect to IBM mainframes via telnet.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+pie
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --with-fontdir=/usr/share/fonts/X11/misc CCOPTIONS='$(CFLAGS)'

override_dh_auto_install:
	dh_auto_install -- install.man

## ibm-3270 4.0ga11

=== debian/changelog ===
ibm-3270 (4.0ga11-2) unstable; urgency=medium

  * Disable parallel installation to fix a race around x3270-script,
    which is installed by multiple programs.
  * Fix CPPFLAGS inheritance in */configure.in.
  * Link mkfb using properly set LDFLAGS.

 -- Philipp Kern <pkern@debian.org>  Mon, 24 Aug 2020 11:01:29 +0200

ibm-3270 (4.0ga11-1) unstable; urgency=medium

  * New upstream release
  * Force PATH to /usr/bin:/bin in debian/rules.

 -- Philipp Kern <pkern@debian.org>  Sat, 22 Aug 2020 15:33:10 +0200

ibm-3270 (4.0ga10-2) unstable; urgency=medium

  * Force LOGNAME to buildd in debian/rules.

 -- Philipp Kern <pkern@debian.org>  Sun, 16 Aug 2020 16:54:33 +0200

ibm-3270 (4.0ga10-1) unstable; urgency=medium

  * New upstream release
  * Add a watch file to find new upstream releases.
  * Bump debhelper compat level to 10 to get automatic autoreconf support.
    (However autoheader does not succeed right now, so it is disabled in
    debian/rules.)

 -- Philipp Kern <pkern@debian.org>  Sun, 02 Aug 2020 15:54:17 +0200

ibm-3270 (3.6ga12-1) unstable; urgency=medium

  * New upstream release

 -- Philipp Kern <pkern@debian.org>  Sun, 26 Apr 2020 15:48:54 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Philipp Kern <pkern@debian.org>
 Standards-Version: 3.9.7
-Build-Depends: debhelper (>> 9), autotools-dev, libncursesw5-dev, libssl-dev, libxaw7-dev, libxt-dev, xbitmaps, xfonts-utils, xutils-dev, tcl, tcl8.6-dev
+Build-Depends: debhelper (>> 10), libncursesw5-dev, libssl-dev, libxaw7-dev, libxt-dev, xbitmaps, xfonts-utils, xutils-dev, tcl, tcl8.6-dev, libexpat1-dev
 Homepage: http://x3270.bgp.nu/
 
 Package: x3270

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export AUTOHEADER=true
export DEB_BUILD_MAINT_OPTIONS=hardening=+pie
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export LOGNAME:=buildd
export PATH:=/usr/bin:/bin

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf obj/ lib/32xx/32xx-deplibs.mk
	find . \
		-name Makefile -or \
		-name Makefile.obj -or \
		-name config.log -or \
		-name config.status -or \
	       	-name conf.h | xargs -r rm

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-fontdir=/usr/share/fonts/X11/misc \
		--enable-x3270 \
		--enable-c3270 \
		--enable-s3270 \
		--enable-b3270 \
		--enable-tcl3270 \
		--enable-pr3287 \
		--enable-x3270if \
		--enable-lib \
		CCOPTIONS='$(CFLAGS)'

override_dh_auto_install:
	dh_auto_install --no-parallel -- install.man
